% Computing mean squred error between a true vector and its estimatation
% University of Alberta 
% Mahdi Shaghaghi
% 31 Aug 2012
% 27 May 2013: return corresponding SE for each frequency 

function [SE_total SE_individual missed_individual]= computeSE(true_data, est_data, thrsh)

% 1) Compute all the possible elementwise distances
% 2) Find the smallest, and omit the corrsponding elements 
% 3) Repeat (2) to the end

n = length(true_data); 
dist = abs(ones(n,1)*transpose(true_data)-est_data*ones(1,n)).^2;
SE_total = 0;
SE_individual = zeros(n,1);
missed_individual = zeros(n,1);

for i = 1:n 
    [min_in_cols,row_idx] = min(dist);
    [smallest,col_idx] = min(min_in_cols);
    SE_total = SE_total+smallest;
    SE_individual(col_idx) = smallest;
    if sqrt(smallest)>thrsh
        missed_individual(col_idx) = 1;
    end 
    dist(:,col_idx) = inf;
    dist(row_idx(col_idx),:) = inf;    
end


